using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Slush.Net;

namespace Slush.Net.Neopets
{
	/// <summary>
	/// Summary description for NeopetsSession.
	/// </summary>
	public class NeopetsSession
	{
	
		private Slush.Net.HTTPSession session;
		
		private string user;
		private string pass;
		private string log;
		private bool loggedOn;

		public string User {get{return user;}}
		public string Pass {get{return pass;}}
		public string LogText {get{return log;}}
		public bool IsLoggedOn {get{return loggedOn;}}


		bool isLoggedOn;

		#region Construction
		public NeopetsSession()
		{
			initGfx();
			session = new Slush.Net.HTTPSession("www.neopets.com");
		}
		#endregion
		
		#region ImageRecognition


		private Bitmap[] chr = new Bitmap[22];
		private char[] chrchr = new char[22];
		

		private void initGfx()
		{
			chr[0] = new Bitmap("C:/char/2.png");
			chrchr[0] = '2';
			chr[1] = new Bitmap("C:/char/3.png");
			chrchr[1] = '3';
			chr[2] = new Bitmap("C:/char/4.png");
			chrchr[2] = '4';
			chr[3] = new Bitmap("C:/char/5.png");
			chrchr[3] = '5';
			chr[4] = new Bitmap("C:/char/6.png");
			chrchr[4] = '6';
			chr[5] = new Bitmap("C:/char/7.png");
			chrchr[5] = '7';
			chr[6] = new Bitmap("C:/char/9.png");
			chrchr[6] = '9';
			chr[7] = new Bitmap("C:/char/C.png");
			chrchr[7] = 'C';
			chr[8] = new Bitmap("C:/char/E.png");
			chrchr[8] = 'E';
			chr[9] = new Bitmap("C:/char/F.png");
			chrchr[9] = 'F';
			chr[10] = new Bitmap("C:/char/G.png");
			chrchr[10] = 'G';
			chr[11] = new Bitmap("C:/char/H.png");
			chrchr[11] = 'H';
			chr[12] = new Bitmap("C:/char/J.png");
			chrchr[12] = 'J';
			chr[13] = new Bitmap("C:/char/K.png");
			chrchr[13] = 'K';
			chr[14] = new Bitmap("C:/char/M.png");
			chrchr[14] = 'M';
			chr[15] = new Bitmap("C:/char/N.png");
			chrchr[15] = 'N';
			chr[16] = new Bitmap("C:/char/P.png");
			chrchr[16] = 'P';
			chr[17] = new Bitmap("C:/char/R.png");
			chrchr[17] = 'R';
			chr[18] = new Bitmap("C:/char/T.png");
			chrchr[18] = 'T';
			chr[19] = new Bitmap("C:/char/W.png");
			chrchr[19] = 'W';
			chr[20] = new Bitmap("C:/char/X.png");
			chrchr[20] = 'X';
			chr[21] = new Bitmap("C:/char/Y.png");
			chrchr[21] = 'Y';

		}

		private bool cequal(Color c1, Color c2)
		{
			return ( (c1.R == c2.R) && (c1.G == c2.G) && (c1.B == c2.B) );
		}

		private string getLetter(Bitmap bmp)
		{
			int min = 1000000;
			char minChr = ' ';
			for(int i = 0; i < 22; i ++)
			{
				int diff = getDiff(bmp, chr[i]);
				if(diff < min) 
				{
					min = diff;
					minChr = chrchr[i];
				}
			}
			//bmp.Save(counter.ToString() + ".png");
			//counter ++;
			return minChr.ToString();
		}

		private int getDiff(Bitmap bmp1, Bitmap bmp2)
		{
			int diff = 0;
			for(int x = 0; x < 8; x++)
			{
				for(int y = 0; y < 10; y++)
				{
					Color c1 = bmp1.GetPixel(x, y);
					Color c2 = bmp2.GetPixel(x, y);
					if( bmp1.GetPixel(x, y).A !=  bmp2.GetPixel(x, y).A  )
						diff ++;
				}
			}
			return diff;
		}

		private string getCode(Slush.Net.HTTPSession session, string fjv, string fdv, string dbi)
		{
			Slush.Net.WebBitmap wbmp = new Slush.Net.WebBitmap(session, "/secret_image.phtml?fjv=" + fjv + "&fdv=" + fdv + "&dbi=" + dbi);
			//http://www.neopets.com/secret_image.phtml?fjv=54920349&fdv=6&dbi=48
			//Graphics g = CreateGraphics();
			//g.DrawImageUnscaled(wbmp, 200, 20, 100, 100);

			// The image is actually first drawn at 60x15, then stretched to 120x30
			// The lines are drawn through AFTER it is stretched (with a width of 1!)
			// so we can actually completely remove the lines across the text!
			//
			// This is how the image is laid out:
			//          6 px 
			//    ----------------- 
			//6 px|               | 8 px
			//    -----------------
			//          4 px

			// The first thing we need to do is make a histogram to determine what colors are static,
			// and what color is used for the line

			Bitmap bmp2 = (Bitmap)wbmp;
			// For some reason we have to make a copy... I think it has to do with the conversion operator
			Bitmap bmp = new Bitmap(bmp2);

			
			


			Hashtable histogram = new Hashtable();

			for(int x = 0; x < 120 - 1; x++)
			{
				for(int y = 0; y < 30 - 1;y ++)
				{
					// This isn't a strict histogram...
					// Originally, we did a strict histogram and took the most common color,
					// but it wasn't as accurate as i thought it would be. We got it right
					// at least 80% of the time, but it was too low, when 100% seems
					// concievable.

					// Instead, we count the number of times that there is a block of four
					// pixels aranged adjacent to each other. this will nearly never happen
					// for the line color or the noise colors, but should happen alot
					// for the text color. 


					//     Completely unneccessary diagram
					//     -------------------------------
					//
					//	     x    x+1
					//	    +----+----+
					//	y   | c1 | c2 |
					//	    +----+----+
					//	y+1 | c3 | c4 |
					//	    +----+----+


					Color c1 = bmp.GetPixel(x, y);
					Color c2 = bmp.GetPixel(x + 1, y);
					Color c3 = bmp.GetPixel(x, y + 1);
					Color c4 = bmp.GetPixel(x + 1, y + 1);

					if(cequal(c1, c2) && cequal(c1, c3) && cequal(c1, c4))
					{
						if(!histogram.ContainsKey(c1))
							histogram[c1] = (int)0;

						histogram[c1] = (int)(histogram[c1]) + 1;
					}

					
				}
			}


			int min = 1000000;
			Color minColor = Color.White;
			int max = 0;
			Color maxColor = Color.Black;

			foreach (DictionaryEntry entry in histogram)
			{
				if((int)entry.Value > max)
				{
					maxColor = (Color)entry.Key;
					max = (int)entry.Value;
				} 

				if((int)entry.Value > max)
				{
					minColor = (Color)entry.Key;
					min = (int)entry.Value;
				} 

			}

			// The lowest value is probably the line, while the highest is probably the text.
			
			


			
			for(int x = 0; x < 120; x++)
			{
				for(int y = 0; y < 30; y++)
				{
					Color c = bmp.GetPixel(x, y);
					if(c == maxColor) 
						bmp.SetPixel(x, y, Color.Black);
					else if(c != minColor)
						bmp.SetPixel(x, y, Color.White);
					
				}
			}
			
			//g.DrawImageUnscaled(bmp, 200, 50, 100, 100);

			Bitmap finalBmp = new Bitmap(60,15); 
			//addLog("Filtering out lines...");

			for(int x = 0; x < 60; x++)
			{
				for(int y = 0; y < 15; y++)
				{
					Color c = bmp.GetPixel(x * 2, y * 2);
					
					if( cequal(bmp.GetPixel(x * 2, y * 2), Color.Black) ||
						cequal(bmp.GetPixel(x * 2 + 1, y * 2), Color.Black) ||
						cequal(bmp.GetPixel(x * 2, y * 2 + 1), Color.Black) ||
						cequal(bmp.GetPixel(x * 2 + 1, y * 2 + 1), Color.Black) )
						finalBmp.SetPixel(x, y, Color.Black);
				}
			}

			//g.DrawImageUnscaled(finalBmp, 200, 80, 100, 100);

			string code = "";
			
			for(int i = 0; i < 6; i++)
			{
				Bitmap charBmp = new Bitmap(8, 10);
				for(int x = 0; x < 8; x ++)
					for(int y = 0; y < 10; y ++)
						charBmp.SetPixel(x, y, finalBmp.GetPixel(3 + x + i * 9, 3 + y));

				//.DrawImage(charBmp, 0, 0);
				code += getLetter(charBmp);
					
			}

			return code;
		}
		#endregion

		private void addLog(string s)
		{
			if(log == null)
				log = s;
			else
				log += "\r\n" + s;
		}

		// Checks str for the string "The main Neopets site is temporarily down for maintenance."
		// Returns false if the website is down
		private bool checkServerDown(string str)
		{
			if(str.IndexOf("The main Neopets site is temporarily down for maintenance.") == -1)
				return true;

			addLog("Server is down");

			return false;

		}

		public bool Logon(string user, string pass)
		{
			session.clearCookies();
			loggedOn = false;

			// First page asks for username
			String s = session.getFile("/loginpage.phtml");

			Hashtable postData = new Hashtable();

			postData["destination"] = "/petcentral.phtml";
			postData["username"] = user;

			// Submission of first page, getting data from second page, with code and password
			s = session.getFile(postData, "/hi.phtml", "Referer: http://www.neopets.com/loginpage.phtml\r\n");

			// Error checking
			if(s.IndexOf("Sorry, we did not find an account with that username.") != -1)
			{
				addLog("Username doesnt exist: " + user);
				return false;
			}
		
			
			if(!checkServerDown(s)) return false;

			int pos = s.IndexOf("secret_image.phtml?fjv=") + 23;

			int pos2 = s.IndexOf("&fdv=",pos);
			if(pos2 == -1) System.Console.Out.WriteLine(s);

			string fjv = s.Substring(pos, pos2 - pos);

			pos2+=5;
			int pos3 = s.IndexOf("&dbi=", pos2);

			string fdv = s.Substring(pos2, pos3-pos2);

			pos3 += 5;
			int pos4 = s.IndexOf("'", pos3);

			string dbi =  s.Substring(pos3, pos4-pos3);


			string secretcode = getCode(session, fjv, fdv, dbi);

			postData.Clear();

			Slush.Net.PageParser page = new Slush.Net.PageParser(s);

			postData["password"] = pass;
			postData["secretcode"] = secretcode;
			postData["username"] = user;
			postData["password_5"] = page.getContained("name='password_5' value='", "'>");
			
			session.getFileWithReferer(postData, "/login.phtml", "http://www.neopets.com/hi.phtml");
			// Error checking
			if(s.IndexOf("security code") != -1)
			{
				addLog("Security code invalid for " + user + ", code = " + secretcode);
				return false;
			}

			if(s.IndexOf("username/password") != -1)
			{
				addLog("Bad password, user: " + user + ", pass: " + pass);
				return false;
			}
		
			
			if(!checkServerDown(s)) return false;
			
			
				
		    this.user = user;
			this.pass = pass;
			loggedOn = true;

			return true;

		}


		public bool Activate(string code)
		{
			session.getFile("http://www.neopets.com/activate.phtml?code=" + code);
			System.IO.StreamWriter stream = System.IO.File.AppendText("C:/np.txt");

			stream.WriteLine(user + " " + pass);
			stream.Close();

			return true;
		}

		public void SaveSession(string sessionName)
		{
			session.saveCookies(sessionName);
		}
	}
}
