using System;

namespace Slush.Net
{
	/// <summary>
	/// Summary description for SlushPacket.
	/// </summary>
	public class SlushPacket
	{
		byte typ;
		byte [] data;

		public byte Type
		{
			get
			{
				return typ;
			}
		}

		public byte[] Data
		{
			get
			{
				return data;
			}
		}

		public string StrData
		{
			get
			{
				return System.Text.ASCIIEncoding.ASCII.GetString(data, 0, data.Length);
			}
		}

		public byte[] GetBytes()
		{
			int len = data.Length;
			byte []sdata = new byte[data.Length + 3];
			sdata[0] = typ;
			sdata[2] = (byte)(len % 256);
			sdata[1] = (byte)(len / 256);
			data.CopyTo(sdata, 3);
			return sdata;
		}

		public SlushPacket(byte type, string sdata)
		{
			typ = type;
			data = new byte[sdata.Length];
			System.Text.ASCIIEncoding.ASCII.GetBytes(sdata, 0, sdata.Length, data, 0);
			
		}

		public SlushPacket(byte type, byte []bdata)
		{
			typ = type;
			data = new byte[bdata.Length];
			bdata.CopyTo(data, 0);
		}

	}
}
