using System;
using System.Collections;
using System.Net.Sockets;
using System.Net;
using System.Text;
using System.Data;
using System.Runtime.Remoting.Messaging;

namespace Slush.Net
{
	/// <summary>
	/// Summary description for SlushSock.
	/// </summary>
	public class SlushSock
	{
		IPAddress hostAddress;
		IPEndPoint hostEndpoint;
		Socket sock;
		int myPort;
		bool isConnected = false;
		
		ArrayList incomingList;

		public SlushSock(int port)
		{
            myPort = port;			
		}

		public SlushSock(Socket s)
		{
			sock = s;
			
			isConnected = s.Connected;
		}

		public bool Connect(string ipAddress)
		{
			if(isConnected) Disconnect();
            hostAddress = Dns.Resolve(ipAddress).AddressList[0];
			hostEndpoint = new IPEndPoint(hostAddress, myPort);

			sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream,
				ProtocolType.Tcp );
			
			sock.Connect(hostEndpoint);

			if (!sock.Connected) return false;

			isConnected = true;
			return true;
		}

		public void ListenCallback(IAsyncResult a)
		{
			System.Console.Out.WriteLine("Hellow");
			//incomingList.Add(sock.EndAccept(a));
			//AsyncCallback async = new AsyncCallback(ListenCallback);
			//sock.BeginAccept(async, sock);
		}
		IAsyncResult asyncResult;
		public void Listen()
		{
			sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
			IPAddress i = Dns.Resolve(Dns.GetHostName()).AddressList[0];
			sock.Bind(new IPEndPoint(i, myPort));
			sock.Listen(10);
			AsyncCallback async = new AsyncCallback(ListenCallback);
			asyncResult = sock.BeginAccept(async, sock);
			//System.Console.Out.WriteLine("Began accept");

			//sock.SetSocketOption(SocketOptionLevel.Tcp, SocketOptionName.ReceiveTimeout, 10);
		}

		public SlushSock Accept()
		{
			
			if(sock == null) return null;
			if(!asyncResult.IsCompleted) return null;
			Socket s = sock.EndAccept(asyncResult);
			AsyncCallback async = new AsyncCallback(ListenCallback);
			asyncResult = sock.BeginAccept(async, sock);
			//Socket s = sock.Accept();
			if(s == null) return null;
			return new SlushSock(s);

			//return null;
		}

		public bool IsConnected()
		{
			if(sock == null) return false;
			return sock.Connected;
		}

		public bool Disconnect()
		{
			if((sock == null) || !sock.Connected) return false;
			sock.Close();
			isConnected = false;
			return true;
		}

		public bool HasData()
		{
			if((sock == null) || !sock.Connected) return false;
			return (sock.Available != 0);
		}

		public int Available()
		{
			if((sock == null) || !sock.Connected) return 0;
			return sock.Available;
		}

		public byte[] GetData(int size)
		{
			if((sock == null) || !sock.Connected) return new byte[0];
			byte[] ret = new byte[size];

            sock.Receive(ret,0, size, SocketFlags.None);

			return ret;
		}

		public SlushPacket GetPacket()
		{
			if((sock == null) || !sock.Connected) return null;
			if(!HasData()) return null;
			byte []d = GetData(3); // 1 byte for type, 2 for size
			int size = d[1] * 256 + d[2];
			byte []data = GetData(size);
			return new SlushPacket(d[0], data);
		}

		public bool sendData(byte[] data)
		{
			if((sock == null) || !sock.Connected) return false;
			try
			{
				sock.Send(data, 0, data.Length, SocketFlags.None);
			} 
			catch (Exception e) 
			{
				System.Console.Out.WriteLine(e.StackTrace);
			}
            return true;
		}

		public bool sendData(SlushPacket p)
		{
			if((sock == null) || !sock.Connected) return false;
			byte []sdata = p.GetBytes();
			return sendData(sdata);
		}
	}
}
