using System;
using System.IO;
using System.Drawing;

namespace Slush.Net
{
	/// <summary>
	/// A specialization of Bitmap that allows images to be loaded from a url
	/// </summary>
	public class WebBitmap
	{
		Bitmap bmp;

		public WebBitmap(string host, string URL)
		{
			HTTPSession sess = new HTTPSession(host);
			Byte []imgBytes = sess.getBinary(URL);
			//string s = System.Text.ASCIIEncoding.ASCII.GetString(imgBytes);
			MemoryStream m = new MemoryStream(imgBytes);
			bmp = new Bitmap(m);
		}

		public WebBitmap(HTTPSession sess, string URL)
		{
			Byte []imgBytes = sess.getBinary(URL);

			MemoryStream m = new MemoryStream(imgBytes);
			bmp = new Bitmap(m);			
		}

		public static implicit operator System.Drawing.Bitmap(WebBitmap webBmp)
		{
			return webBmp.bmp;
		}
	}
}
